Index: moodle/backup/util/ui/restore_ui_stage.class.php
--- moodle/backup/util/ui/restore_ui_stage.class.php No Base Revision
+++ moodle/backup/util/ui/restore_ui_stage.class.php Locally New
@@ -0,0 +1,593 @@
+<?php
+
+
+// This file is part of Moodle - http://moodle.org/
+//
+// Moodle is free software: you can redistribute it and/or modify
+// it under the terms of the GNU General Public License as published by
+// the Free Software Foundation, either version 3 of the License, or
+// (at your option) any later version.
+//
+// Moodle is distributed in the hope that it will be useful,
+// but WITHOUT ANY WARRANTY; without even the implied warranty of
+// MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
+// GNU General Public License for more details.
+//
+// You should have received a copy of the GNU General Public License
+// along with Moodle.  If not, see <http://www.gnu.org/licenses/>.
+
+/**
+ * restore user interface stages
+ *
+ * This file contains the classes required to manage the stages that make up the
+ * restore user interface.
+ * These will be primarily operated a {@see restore_ui} instance.
+ *
+ * @package   moodlecore
+ * @copyright 2010 Sam Hemelryk
+ * @license   http://www.gnu.org/copyleft/gpl.html GNU GPL v3 or later
+ */
+
+/**
+ * Abstract stage class
+ *
+ * This class should be extended by all restore stages (a requirement of many restore ui functions).
+ * Each stage must then define two abstract methods
+ *  - process : To process the stage
+ *  - initialise_stage_form : To get a restore_moodleform instance for the stage
+ *
+ * @copyright 2010 Sam Hemelryk
+ * @license   http://www.gnu.org/copyleft/gpl.html GNU GPL v3 or later
+ */
+abstract class restore_ui_stage extends base_ui_stage {
+    /**
+     *
+     * @param restore_ui $ui
+     */
+    public function __construct(restore_ui $ui, array $params=null) {
+        $this->ui = $ui;
+        $this->params = $params;
+    }
+    /**
+     * The restore id from the restore controller
+     * @return string
+     */
+    final public function get_restoreid() {
+        return $this->get_uniqueid();
+    }
+
+    final public function is_independent() {
+        return false;
+    }
+
+    public function has_sub_stages() {
+        return false;
+    }
+
+    /**
+     * The name of this stage
+     * @return string
+     */
+    final public function get_name() {
+        return get_string('restorestage'.$this->stage,'backup');
+    }
+}
+
+abstract class restore_ui_independent_stage {
+    abstract public function __construct($contextid);
+    abstract public function process();
+    abstract public function display($renderer);
+    abstract public function get_stage();
+    /**
+     * Gets an array of progress bar items that can be displayed through the restore renderer.
+     * @return array Array of items for the progress bar
+     */
+    public function get_progress_bar() {
+        global $PAGE;
+        $stage = restore_ui::STAGE_COMPLETE;
+        $currentstage = $this->get_stage();
+        $items = array();
+        while ($stage > 0) {
+            $classes = array('backup_stage');
+            if (floor($stage/2) == $currentstage) {
+                $classes[] = 'backup_stage_next';
+            } else if ($stage == $currentstage) {
+                $classes[] = 'backup_stage_current';
+            } else if ($stage < $currentstage) {
+                $classes[] = 'backup_stage_complete';
+            }
+            $item = array('text' => strlen(decbin($stage)).'. '.get_string('restorestage'.$stage, 'backup'),'class' => join(' ', $classes));
+            if ($stage < $currentstage && $currentstage < restore_ui::STAGE_COMPLETE) {
+                //$item['link'] = new moodle_url($PAGE->url, array('restore'=>$this->get_restoreid(), 'stage'=>$stage));
+            }
+            array_unshift($items, $item);
+            $stage = floor($stage/2);
+        }
+        return $items;
+    }
+    abstract public function get_stage_name();
+    final public function is_independent() {
+        return true;
+    }
+}
+
+class restore_ui_stage_confirm extends restore_ui_independent_stage {
+    protected $contextid;
+    protected $filename = null;
+    protected $filepath = null;
+    protected $details;
+    public function __construct($contextid) {
+        $this->contextid = $contextid;
+        $this->filename = required_param('filename', PARAM_FILE);
+    }
+    public function process() {
+        global $CFG;
+        if (!file_exists("$CFG->dataroot/temp/backup/".$this->filename)) {
+            throw new restore_ui_exception('invalidrestorefile');
+        }
+        return $this->extract_file_to_dir();
+    }
+    protected function extract_file_to_dir() {
+        global $CFG, $USER;
+
+        $this->filepath = restore_controller::get_tempdir_name($this->contextid, $USER->id);
+
+        $fb = get_file_packer();
+        return ($fb->extract_to_pathname("$CFG->dataroot/temp/backup/".$this->filename, "$CFG->dataroot/temp/backup/$this->filepath/"));
+    }
+    public function display($renderer) {
+        $this->details = backup_general_helper::get_backup_information($this->filepath);
+        return $renderer->backup_details($this->details, new moodle_url('/backup/restore.php', array('contextid'=>$this->contextid, 'filepath'=>$this->filepath, 'stage'=>restore_ui::STAGE_DESTINATION)));
+    }
+    public function get_stage_name() {
+        return get_string('restorestage'.restore_ui::STAGE_CONFIRM, 'backup');
+    }
+    public function get_stage() {
+        return restore_ui::STAGE_CONFIRM;
+    }
+}
+
+class restore_ui_stage_destination extends restore_ui_independent_stage {
+    protected $contextid;
+    protected $filepath = null;
+    protected $details;
+    protected $courseid = null;
+    public function __construct($contextid) {
+        $this->contextid = $contextid;
+        $this->filepath = required_param('filepath', PARAM_ALPHANUM);
+    }
+    public function process() {
+        global $CFG, $DB;
+        if (!file_exists("$CFG->dataroot/temp/backup/".$this->filepath) || !is_dir("$CFG->dataroot/temp/backup/".$this->filepath)) {
+            throw new restore_ui_exception('invalidrestorepath');
+        }
+        $target = optional_param('target', null, PARAM_INT);
+        if (!is_null($target) && confirm_sesskey()) {
+            $targetid = required_param('targetid', PARAM_INT);
+            if ($target == backup::TARGET_NEW_COURSE) {
+                list($fullname, $shortname) = restore_dbops::calculate_course_names(0, get_string('restoringcourse', 'backup'), get_string('restoringcourseshortname', 'backup'));
+                $this->courseid = restore_dbops::create_new_course($fullname, $shortname, $targetid);
+            } else {
+                $this->courseid = $targetid;
+            }
+            return ($DB->record_exists('course', array('id'=>$this->courseid)));
+        }
+        return false;
+    }
+    /**
+     *
+     * @global moodle_database $DB
+     * @param core_backup_renderer $renderer
+     * @return string
+     */
+    public function display($renderer) {
+        global $DB;
+        $this->details = backup_general_helper::get_backup_information($this->filepath);
+        $url = new moodle_url('/backup/restore.php', array('contextid'=>$this->contextid, 'filepath'=>$this->filepath, 'stage'=>restore_ui::STAGE_SETTINGS));
+        $context = get_context_instance_by_id($this->contextid);
+        $currentcourse = ($context->contextlevel == CONTEXT_COURSE)?$context->instanceid:false;
+        $courselist = array();
+        $courses = $DB->get_recordset('course', array(), 'id,fullname,shortname');
+        foreach ($courses as $course) {
+            $courselist[$course->id] = $course->fullname.' ['.$course->shortname.']';
+        }
+        $courses->close();
+        $html = $renderer->course_selector($url, $this->details, make_categories_options(), $courselist, $currentcourse);
+        return $html;
+    }
+    public function get_stage_name() {
+        return get_string('restorestage'.restore_ui::STAGE_DESTINATION, 'backup');
+    }
+    public function get_filepath() {
+        return $this->filepath;
+    }
+    public function get_course_id() {
+        return $this->courseid;
+    }
+    public function get_stage() {
+        return restore_ui::STAGE_DESTINATION;
+    }
+}
+
+class restore_ui_stage_settings extends restore_ui_stage {
+    /**
+     * Initial restore stage constructor
+     * @param restore_ui $ui
+     */
+    public function __construct(restore_ui $ui, array $params=null) {
+        $this->stage = restore_ui::STAGE_SETTINGS;
+        parent::__construct($ui, $params);
+    }
+
+    public function process(base_moodleform $form=null) {
+        $form = $this->initialise_stage_form();
+
+        if ($form->is_cancelled()) {
+            $this->ui->cancel_restore();
+        }
+
+        $data = $form->get_data();
+        if ($data && confirm_sesskey()) {
+            $tasks = $this->ui->get_tasks();
+            $changes = 0;
+            foreach ($tasks as &$task) {
+                // We are only interesting in the backup root task for this stage
+                if ($task instanceof restore_root_task || $task instanceof restore_course_task) {
+                    // Get all settings into a var so we can iterate by reference
+                    $settings = $task->get_settings();
+                    foreach ($settings as &$setting) {
+                        $name = $setting->get_ui_name();
+                        if (isset($data->$name) &&  $data->$name != $setting->get_value()) {
+                            $setting->set_value($data->$name);
+                            $changes++;
+                        } else if (!isset($data->$name) && $setting->get_ui_type() == backup_setting::UI_HTML_CHECKBOX && $setting->get_value()) {
+                            $setting->set_value(0);
+                            $changes++;
+                        }
+                    }
+                }
+            }
+            // Return the number of changes the user made
+            return $changes;
+        } else {
+            return false;
+        }
+    }
+
+    protected function initialise_stage_form() {
+        global $PAGE;
+        if ($this->stageform === null) {
+            $form = new restore_settings_form($this, $PAGE->url);
+            // Store as a variable so we can iterate by reference
+            $tasks = $this->ui->get_tasks();
+            $headingprinted = false;
+            // Iterate all tasks by reference
+            foreach ($tasks as &$task) {
+                // For the initial stage we are only interested in the root settings
+                if ($task instanceof restore_root_task) {
+                    if (!$headingprinted) {
+                        $form->add_heading('rootsettings', get_string('restorerootsettings', 'backup'));
+                        $headingprinted = true;
+                    }
+                    $settings = $task->get_settings();
+                    // First add all settings except the filename setting
+                    foreach ($settings as &$setting) {
+                        if ($setting->get_name() == 'filename') {
+                            continue;
+                        }
+                        $form->add_setting($setting, $task);
+                    }
+                    // Then add all dependencies
+                    foreach ($settings as &$setting) {
+                        if ($setting->get_name() == 'filename') {
+                            continue;
+                        }
+                        $form->add_dependencies($setting);
+                    }
+                }
+            }
+            $this->stageform = $form;
+        }
+        // Return the form
+        return $this->stageform;
+    }
+}
+
+/**
+ * Schema stage of backup process
+ *
+ * During the schema stage the user is required to set the settings that relate
+ * to the area that they are backing up as well as its children.
+ *
+ * @copyright 2010 Sam Hemelryk
+ * @license   http://www.gnu.org/copyleft/gpl.html GNU GPL v3 or later
+ */
+class restore_ui_stage_schema extends restore_ui_stage {
+    /**
+     * Schema stage constructor
+     * @param backup_moodleform $ui
+     */
+    public function __construct(restore_ui $ui, array $params=null) {
+        $this->stage = restore_ui::STAGE_SCHEMA;
+        parent::__construct($ui, $params);
+    }
+    /**
+     * Processes the schema stage
+     *
+     * @param backup_moodleform|null $form
+     * @return int The number of changes the user made
+     */
+    public function process(base_moodleform $form = null) {
+        $form = $this->initialise_stage_form();
+        // Check it wasn't cancelled
+        if ($form->is_cancelled()) {
+            $this->ui->cancel_backup();
+        }
+
+        // Check it has been submit
+        $data = $form->get_data();
+        if ($data && confirm_sesskey()) {
+            // Get the tasks into a var so we can iterate by reference
+            $tasks = $this->ui->get_tasks();
+            $changes = 0;
+            // Iterate all tasks by reference
+            foreach ($tasks as &$task) {
+                // We are only interested in schema settings
+                if (!($task instanceof restore_root_task)) {
+                    // Store as a variable so we can iterate by reference
+                    $settings = $task->get_settings();
+                    // Iterate by reference
+                    foreach ($settings as &$setting) {
+                        $name = $setting->get_ui_name();
+                        if (isset($data->$name) &&  $data->$name != $setting->get_value()) {
+                            $setting->set_value($data->$name);
+                            $changes++;
+                        } else if (!isset($data->$name) && $setting->get_ui_type() == backup_setting::UI_HTML_CHECKBOX && $setting->get_value()) {
+                            $setting->set_value(0);
+                            $changes++;
+                        }
+                    }
+                }
+            }
+            // Return the number of changes the user made
+            return $changes;
+        } else {
+            return false;
+        }
+    }
+    /**
+     * Creates the backup_schema_form instance for this stage
+     *
+     * @return backup_schema_form
+     */
+    protected function initialise_stage_form() {
+        global $PAGE;
+        if ($this->stageform === null) {
+            $form = new restore_schema_form($this, $PAGE->url);
+            $tasks = $this->ui->get_tasks();
+            $content = '';
+            $courseheading = false;
+            foreach ($tasks as $task) {
+                if (!($task instanceof restore_root_task)) {
+                    if (!$courseheading) {
+                        // If we havn't already display a course heading to group nicely
+                        $form->add_heading('coursesettings', get_string('coursesettings', 'backup'));
+                        $courseheading = true;
+                    }
+                    // First add each setting
+                    foreach ($task->get_settings() as $setting) {
+                        $form->add_setting($setting, $task);
+                    }
+                    // The add all the dependencies
+                    foreach ($task->get_settings() as $setting) {
+                        $form->add_dependencies($setting);
+                    }
+                } else if ($this->ui->enforce_changed_dependencies()) {
+                    // Only show these settings if dependencies changed them.
+                    // Add a root settings heading to group nicely
+                    $form->add_heading('rootsettings', get_string('rootsettings', 'backup'));
+                    // Iterate all settings and add them to the form as a fixed
+                    // setting. We only want schema settings to be editable
+                    foreach ($task->get_settings() as $setting) {
+                        if ($setting->get_name() != 'filename') {
+                            $form->add_fixed_setting($setting);
+                        }
+                    }
+                }
+            }
+            $this->stageform = $form;
+        }
+        return $this->stageform;
+    }
+}
+
+/**
+ * Confirmation stage
+ *
+ * On this stage the user reviews the setting for the backup and can change the filename
+ * of the file that will be generated.
+ *
+ * @copyright 2010 Sam Hemelryk
+ * @license   http://www.gnu.org/copyleft/gpl.html GNU GPL v3 or later
+ */
+class restore_ui_stage_review extends restore_ui_stage {
+    /**
+     * Constructs the stage
+     * @param backup_ui $ui
+     */
+    public function __construct($ui, array $params=null) {
+        $this->stage = restore_ui::STAGE_REVIEW;
+        parent::__construct($ui, $params);
+    }
+    /**
+     * Processes the confirmation stage
+     *
+     * @param backup_moodleform $form
+     * @return int The number of changes the user made
+     */
+    public function process(base_moodleform $form = null) {
+        $form = $this->initialise_stage_form();
+        // Check it hasn't been cancelled
+        if ($form->is_cancelled()) {
+            $this->ui->cancel_backup();
+        }
+
+        $data = $form->get_data();
+        if ($data && confirm_sesskey()) {
+            return 0;
+        } else {
+            return false;
+        }
+    }
+    /**
+     * Creates the backup_confirmation_form instance this stage requires
+     *
+     * @return backup_confirmation_form
+     */
+    protected function initialise_stage_form() {
+        global $PAGE;
+        if ($this->stageform === null) {
+            // Get the form
+            $form = new restore_review_form($this, $PAGE->url);
+            $content = '';
+            $courseheading = false;
+
+            foreach ($this->ui->get_tasks() as $task) {
+                if ($task instanceof restore_root_task) {
+                    // If its a backup root add a root settings heading to group nicely
+                    $form->add_heading('rootsettings', get_string('rootsettings', 'backup'));
+                } else if (!$courseheading) {
+                    // we havn't already add a course heading
+                    $form->add_heading('coursesettings', get_string('coursesettings', 'backup'));
+                    $courseheading = true;
+                }
+                // Iterate all settings, doesnt need to happen by reference
+                foreach ($task->get_settings() as $setting) {
+                    $form->add_fixed_setting($setting);
+                }
+            }
+            $this->stageform = $form;
+        }
+        return $this->stageform;
+    }
+}
+
+/**
+ * Final stage of backup
+ *
+ * This stage is special in that it is does not make use of a form. The reason for
+ * this is the order of procession of backup at this stage.
+ * The processesion is:
+ * 1. The final stage will be intialise.
+ * 2. The confirmation stage will be processed.
+ * 3. The backup will be executed
+ * 4. The complete stage will be loaded by execution
+ * 5. The complete stage will be displayed
+ *
+ * This highlights that we neither need a form nor a display method for this stage
+ * we simply need to process.
+ *
+ * @copyright 2010 Sam Hemelryk
+ * @license   http://www.gnu.org/copyleft/gpl.html GNU GPL v3 or later
+ */
+class restore_ui_stage_process extends restore_ui_stage {
+
+    const SUBSTAGE_NONE = 0;
+    const SUBSTAGE_CONVERT = 1;
+    const SUBSTAGE_PRECHECKS = 2;
+
+    protected $substage = 0;
+
+    /**
+     * Constructs the final stage
+     * @param backup_ui $ui
+     */
+    public function __construct(base_ui $ui, array $params=null) {
+        $this->stage = restore_ui::STAGE_PROCESS;
+        parent::__construct($ui, $params);
+    }
+    /**
+     * Processes the final stage.
+     *
+     * In this case it checks to see if there is a sub stage that we need to display
+     * before execution, if there is we gear up to display the subpage, otherwise
+     * we return true which will lead to execution of the restore and the loading
+     * of the completed stage.
+     */
+    public function process(base_moodleform $form=null) {
+        $rc = $this->ui->get_controller();
+        if ($rc->get_status() == backup::STATUS_REQUIRE_CONV) {
+            $this->substage = self::SUBSTAGE_CONVERT;
+        } else {
+            if ($rc->get_status() == backup::STATUS_SETTING_UI) {
+                $rc->finish_ui();
+            }
+            if ($rc->get_status() == backup::STATUS_NEED_PRECHECK && !$rc->execute_precheck(true)) {
+                $this->substage = self::SUBSTAGE_PRECHECKS;
+            }
+        }
+        return empty($this->substage);
+    }
+    /**
+     * should NEVER be called... throws an exception
+     */
+    protected function initialise_stage_form() {
+        throw new backup_ui_exception('backup_ui_must_execute_first');
+    }
+    /**
+     * should NEVER be called... throws an exception
+     */
+    public function display($renderer) {
+        global $PAGE;
+        switch ($this->substage) {
+            case self::SUBSTAGE_CONVERT :
+                echo '<h2>Need to show the conversion screens here</h2>';
+                break;
+            case self::SUBSTAGE_PRECHECKS :
+                $results = $this->ui->get_controller()->get_precheck_results();
+                echo $renderer->precheck_notices($results);
+                break;
+            default:
+                throw new restore_ui_exception('backup_ui_must_execute_first');
+        }
+        echo $renderer->continue_button(new moodle_url($PAGE->url, array('restore'=>$this->get_uniqueid(), 'stage'=>restore_ui::STAGE_PROCESS, 'substage'=>$this->substage)));
+    }
+
+    public function has_sub_stages() {
+        return true;
+    }
+}
+
+class restore_ui_stage_complete extends restore_ui_stage_process {
+    /**
+     * The results of the backup execution
+     * @var array
+     */
+    protected $results;
+    /**
+     * Constructs the complete backup stage
+     * @param backup_ui $ui
+     * @param array|null $params
+     * @param array $results
+     */
+    public function __construct(restore_ui $ui, array $params=null, array $results=null) {
+        $this->results = $results;
+        parent::__construct($ui, $params);
+        $this->stage = restore_ui::STAGE_COMPLETE;
+    }
+    /**
+     * Displays the completed backup stage.
+     *
+     * Currently this just envolves redirecting to the file browser with an
+     * appropriate message.
+     *
+     * @global core_renderer $OUTPUT
+     */
+    public function display($renderer) {
+        global $OUTPUT;
+        echo $OUTPUT->box_start();
+        echo $OUTPUT->notification(get_string('restoreexecutionsuccess', 'backup'), 'notifysuccess');
+        echo $renderer->continue_button(new moodle_url('/course/view.php', array('id'=>$this->get_ui()->get_controller()->get_courseid())));
+        echo $OUTPUT->box_end();
+    }
+}
\ No newline at end of file
Index: moodle/lang/en/backup.php
--- moodle/lang/en/backup.php Base (1.10)
+++ moodle/lang/en/backup.php Locally Modified (Based On 1.10)
@@ -23,9 +23,28 @@
  * @license   http://www.gnu.org/copyleft/gpl.html GNU GPL v3 or later
  */
 
+$string['backupactivity'] = 'Backup activity: {$a}';
 $string['backupcourse'] = 'Backup course: {$a}';
+$string['backupcoursedetails'] = 'Course details';
+$string['backupcoursesection'] = 'Section: {$a}';
+$string['backupcoursesections'] = 'Course sections';
+$string['backupdate'] = 'Date taken';
+$string['backupdetails'] = 'Backup details';
+$string['backupformat'] = 'Format';
+$string['backupformatmoodle2'] = 'Moodle 2';
+$string['backupmode'] = 'Mode';
+$string['backupmode10'] = 'General';
 $string['backupsection'] = 'Backup course section: {$a}';
-$string['backupactivity'] = 'Backup activity: {$a}';
+$string['backupsettings'] = 'Backup settings';
+$string['backupsitedetails'] = 'Site details';
+$string['backupstage1action'] = 'Next';
+$string['backupstage2action'] = 'Next';
+$string['backupstage4action'] = 'Perform backup';
+$string['backupstage8action'] = 'Continue';
+$string['backupstage16action'] = 'Continue';
+$string['backuptype'] = 'Type';
+$string['backuptypecourse'] = 'Course';
+$string['backupversion'] = 'Backup version';
 $string['cannotfindassignablerole'] = 'The {$a} role in the backup file cannot be mapped to any of the roles that you are allowed to assign.';
 $string['choosefile'] = 'Choose an existing backup file';
 $string['configgeneralactivities'] = 'Sets the default for including activities in a backup.';
@@ -39,7 +58,10 @@
 $string['configgeneraluserscompletion'] = 'If enabled user completion information will be included in backups by default.';
 $string['configgeneraluserfiles'] = 'Sets the default for whether user files will be included in backups.';
 $string['configgeneralusers'] = 'Sets the default for whether to include users in backups.';
+$string['coursecategory'] = 'Category the course will be restored into';
+$string['courseid'] = 'Original ID';
 $string['coursesettings'] = 'Course settings';
+$string['coursetitle'] = 'Title';
 $string['currentstage1'] = 'Initial settings';
 $string['currentstage2'] = 'Schema settings';
 $string['currentstage4'] = 'Confirmation and review';
@@ -59,6 +81,7 @@
 $string['generalcomments'] = 'Include comments';
 $string['generalfilters'] = 'Include filters';
 $string['generalhistories'] = 'Include histories';
+$string['generalgradehistories'] = 'Include histories';
 $string['generallogs'] = 'Include logs';
 $string['generalroleassignments'] = 'Include role assignments';
 $string['generaluserscompletion'] = 'Include user completion information';
@@ -72,14 +95,49 @@
 $string['lockedbypermission'] = 'You don\'t have sufficient permissions to change this setting';
 $string['lockedbyconfig'] = 'This setting has been locked by the default backup settings';
 $string['lockedbyhierarchy'] = 'Locked by dependencies';
-$string['onstage1action'] = 'Next';
-$string['onstage2action'] = 'Next';
-$string['onstage4action'] = 'Perform backup';
-$string['onstage8action'] = 'Continue';
-$string['onstage16action'] = 'Continue';
+$string['moodleversion'] = 'Moodle version';
+$string['originalwwwroot'] = 'URL of backup';
 $string['previousstage'] = 'Previous';
 $string['restoreactivity'] = 'Restore activity';
 $string['restorecourse'] = 'Restore course';
+$string['restorecoursesettings'] = 'Course settings';
+$string['restoreexecutionsuccess'] = 'The course was restored successfully, clicking the continue button below will take you to view the course you restored.';
+$string['restorenewcoursefullname'] = 'New course name';
+$string['restorenewcourseshortname'] = 'New course short name';
+$string['restorenewcoursestartdate'] = 'New start date';
+$string['restorerootsettings'] = 'Restore settings';
 $string['restoresection'] = 'Restore section';
+$string['restorestage1'] = 'Confirm';
+$string['restorestage1action'] = 'Next';
+$string['restorestage2'] = 'Destination';
+$string['restorestage2action'] = 'Next';
+$string['restorestage4'] = 'Settings';
+$string['restorestage4action'] = 'Next';
+$string['restorestage8'] = 'Schema';
+$string['restorestage8action'] = 'Next';
+$string['restorestage16'] = 'Review';
+$string['restorestage16action'] = 'Perform restore';
+$string['restorestage32'] = 'Process';
+$string['restorestage32action'] = 'Continue';
+$string['restorestage64'] = 'Complete';
+$string['restorestage64action'] = 'Continue';
+$string['restoretarget'] = 'Restore target';
+$string['restoretocourse'] = 'Restore to course: ';
+$string['restoretocurrentcourse'] = 'Restore into this course';
+$string['restoretocurrentcourseadding'] = 'Merge the backup course into this course';
+$string['restoretocurrentcoursedeleting'] = 'Delete the contents of this course and then restore';
+$string['restoretoexistingcourse'] = 'Restore into an existing course';
+$string['restoretoexistingcourseadding'] = 'Merge the backup course into the existing course';
+$string['restoretoexistingcoursedeleting'] = 'Delete the contents of the existing course and then restore';
+$string['restoretonewcourse'] = 'Restore as a new course';
+$string['restoringcourse'] = 'Course restoration in progress';
+$string['restoringcourseshortname'] = 'restoring';
 $string['rootsettings'] = 'Backup settings';
 $string['scheduledsettings'] = 'Scheduled backup settings';
+$string['sectionincanduser'] = 'Included in backup along with user information';
+$string['sectioninc'] = 'Included in backup (no user information)';
+$string['sectionactivities'] = 'Activities';
+$string['setting_overwriteconf'] = 'Overwrite course configuration';
+$string['setting_course_fullname'] = 'Course name';
+$string['setting_course_shortname'] = 'Course short name';
+$string['setting_course_startdate'] = 'Course startdate';
Index: moodle/lib/navigationlib.php
--- moodle/lib/navigationlib.php Base (1.155)
+++ moodle/lib/navigationlib.php Locally Modified (Based On 1.155)
@@ -2678,8 +2678,7 @@
 
         // Restore to this course
         if (has_capability('moodle/restore:restorecourse', $coursecontext)) {
-            $url = new moodle_url('/files/index.php', array('contextid'=>$coursecontext->id, 'itemid'=>0, 'component' => 'backup', 'filearea'=>'course'));
-            $url = null; // Disabled until restore is implemented. MDL-21432
+            $url = new moodle_url('/backup/restorefile.php', array('contextid'=>$coursecontext->id));
             $coursenode->add(get_string('restore'), $url, self::TYPE_SETTING, null, 'restore', new pix_icon('i/restore', ''));
         }
 
